#include "stdafx.h"
#include "ScrollBarUI_Solid.h"

//////////////////////////////////////////////////////////////////////////
// {kr} ⺻ . {/kr}
static const CScrollBarUI_Solid::SCROLLBARUI_SOLID_INFO SBUISOLID_INFO_DEF = 
{
	RGB(0x0, 0x0, 0xaa), //COLORREF clrBtn;
	RGB(0x0, 0xaa, 0x0), //COLORREF clrThumb;
	RGB(0xdd, 0xdd, 0xdd), //COLORREF clrBgNormal;
	RGB(0xaa, 0xaa, 0xaa), //COLORREF clrBgSelected;
	TRUE, //BOOL bHorz;
};

//////////////////////////////////////////////////////////////////////////

IMPLEMENT_RTTI(CScrollBarUI_Solid, IScrollBarUI)

CScrollBarUI_Solid::CScrollBarUI_Solid( PSCROLLBARUI_SOLID_INFO pInfo /*= NULL*/ )
{
	if (pInfo != NULL)
	{
		::CopyMemory(&m_Info, pInfo, sizeof(SCROLLBARUI_SOLID_INFO));
	}
	else
	{
		::CopyMemory(&m_Info, &SBUISOLID_INFO_DEF, sizeof(SCROLLBARUI_SOLID_INFO));
	}
	
	m_pPanelUI_LeftTop.Attach(new CPanelUI_ScrollBarUI(m_Info.clrBtn));
	m_pPanelUI_RightBottom.Attach(new CPanelUI_ScrollBarUI(m_Info.clrBtn));
	m_pPanelUI_Thumb.Attach(new CPanelUI_ScrollBarUI(m_Info.clrThumb));
}

CScrollBarUI_Solid::~CScrollBarUI_Solid()
{

}

void CScrollBarUI_Solid::DrawBackground( HDC hDC, CNScrollBar* pNSB, PRECT pRcShaftSelected )
{
	CRect rcNsb;
	pNSB->GetClientRect(&rcNsb);
	m_Info.bHorz = (rcNsb.Width() > rcNsb.Height());

	// {kr} Normal . {/kr}
	CRect rcDest1(&rcNsb);
	::FillSolidRect(hDC, &rcDest1, m_Info.clrBgNormal);

	// {kr} Selected . {/kr}
	::FillSolidRect(hDC, pRcShaftSelected, m_Info.clrBgSelected);
}

IPanelUI* CScrollBarUI_Solid::GetLUPanelUI()
{
	return m_pPanelUI_LeftTop.m_p;
}

IPanelUI* CScrollBarUI_Solid::GetRDPanelUI()
{
	return m_pPanelUI_RightBottom.m_p;
}

IPanelUI* CScrollBarUI_Solid::GetThumbPanelUI()
{
	return m_pPanelUI_Thumb.m_p;
}

IPanelUI* CScrollBarUI_Solid::GetHandlePanelUI()
{
	return m_pPanelUI_Thumb.m_p;
}

//////////////////////////////////////////////////////////////////////////

IMPLEMENT_RTTI(CScrollBarUI_Solid::CPanelUI_ScrollBarUI, IPanelUI)

CScrollBarUI_Solid::CPanelUI_ScrollBarUI::CPanelUI_ScrollBarUI( COLORREF clr )
{
	m_clr = clr;
}

CScrollBarUI_Solid::CPanelUI_ScrollBarUI::~CPanelUI_ScrollBarUI()
{

}

void CScrollBarUI_Solid::CPanelUI_ScrollBarUI::DrawPanel( HDC hDC, CNPanel* pPanel )
{
	CRect rcDest;
	pPanel->GetClientRect(&rcDest);
	::FillSolidRect(hDC, &rcDest, m_clr);
}